---
include:
  - local: "/jobs/container/snippets.yml"

container-push-default:
  extends: .container_default
  stage: deploy
  script:
    # Allows to interpret simple commands in CONTAINER_IMAGE_PUSH_TAG env var
    - export CONTAINER_IMAGE_PUSH_TAG=$(sh -c "echo $CONTAINER_IMAGE_PUSH_TAG")
    - ${OCI_CONTAINER_ENGINE_BIN} manifest create "image-manifest:${CI_COMMIT_SHA}"
    - IFS=','; for arch in $PUBLISH_ARCHITECTURES; do ${OCI_CONTAINER_ENGINE_BIN} manifest add "image-manifest:${CI_COMMIT_SHA}" docker-archive:built-image-${arch}.tar; done
    - ${OCI_CONTAINER_ENGINE_BIN} tag "image-manifest:${CI_COMMIT_SHA}" ${CI_REGISTRY_IMAGE}:${CONTAINER_IMAGE_PUSH_TAG}
    - ${OCI_CONTAINER_ENGINE_BIN} manifest inspect "image-manifest:${CI_COMMIT_SHA}"
    - ${OCI_CONTAINER_ENGINE_BIN} manifest push --all "image-manifest:${CI_COMMIT_SHA}" "docker://${CI_REGISTRY_IMAGE}:${CONTAINER_IMAGE_PUSH_TAG}"
    - echo "Container image pushed with the tag “${CONTAINER_IMAGE_PUSH_TAG}”"
  variables:
    CONTAINER_IMAGE_PULL_TAG: ${CI_COMMIT_SHA}
    CONTAINER_IMAGE_PUSH_TAG: ${CI_COMMIT_SHA}
    GIT_STRATEGY: "none"
  needs:
    - container-default-build
  parallel:
    matrix:
      - CONTAINER_IMAGE_PUSH_TAG:
          - ${CI_COMMIT_SHA}
          - ${CI_COMMIT_SHA}.$(date +%Y%m%d)

container-default-push-default-branch:
  extends: container-push-default
  variables:
    CONTAINER_IMAGE_PUSH_TAG: ${CI_DEFAULT_BRANCH}
  only:
    - ${CI_DEFAULT_BRANCH}

container-push-tags:
  extends: container-push-default
  only:
    - tags
  parallel:
    matrix:
      - CONTAINER_IMAGE_PUSH_TAG:
          - ${CI_COMMIT_REF_NAME}
          - "latest"
